MODULE Firma;

(* Programm zum Einlesen der Namen von Angestellten einer Firma
   und deren Gehalt.
   Es kann dann das jeweilige Gehalt von bestimmten Personen ausgegeben
   werden oder die Personen innerhalb einer gewissen Gehaltsspanne.
*)

FROM Storage IMPORT ALLOCATE,DEALLOCATE;
FROM IO IMPORT WrLn,WrStr,RdStr,WrCard;
FROM InOut IMPORT Done,ReadCard;
FROM Str IMPORT Compare,Caps;         (* zum lexikographischen Vergleich *)
                                                    (* zweier Namen *)

 CONST max=50;    (* maximale Lnge der Namen *)

TYPE String=ARRAY[1..max] OF CHAR;    (* fr die Namen *)
     Zeiger=POINTER TO Knoten;
     Knoten=RECORD
              Gehalt:CARDINAL;
              Name  :String;
              linksGehalt,rechtsGehalt,
               linksName,rechtsName      :Zeiger;
            END;

VAR NamensBaum,GehaltsBaum:Zeiger;
           (* in den NamensBaum werden die Namen, in den Gehaltsbaum *)
           (* die Gehlter der jeweiligen Personen eingordnet        *)
    a,b:CARDINAL;
    name:String;
    x:BOOLEAN;
    p:Zeiger;    (* Hilfszeiger *)
    janein:CHAR;

PROCEDURE Einlesen():BOOLEAN;
(* Einlesen des Namens und des Gehalts *)
  BEGIN
    NEW(p);
     WrStr('Name: ');
    RdStr(p^.Name);
    IF p^.Name[1]="*" THEN
      DISPOSE(p);
      RETURN FALSE;
    END;  (* IF *)
    REPEAT
      WrStr('  Gehalt: ');
      ReadCard(p^.Gehalt);
    UNTIL Done;
    WITH p^ DO
      linksGehalt:=NIL;
      rechtsGehalt:=NIL;
      linksName:=NIL;
       rechtsName:=NIL;
    END;  (* WITH *)
    WrLn;
    RETURN TRUE;
  END Einlesen;


PROCEDURE EinfuegenName(VAR NamensBaum:Zeiger);
(* Einfuegen eines Namens in den Namensbaum *)
  BEGIN
    IF NamensBaum=NIL THEN
      NamensBaum:=p;
    ELSE
      IF Compare(p^.Name,NamensBaum^.Name) > 0 THEN
         EinfuegenName(NamensBaum^.rechtsName);
      ELSE
        EinfuegenName(NamensBaum^.linksName);
      END  (* IF *)
    END  (* IF *)
  END EinfuegenName;


PROCEDURE EinfuegenGehalt(VAR GehaltsBaum:Zeiger);
(* Einfuegen des Gehalts in den Gehaltsbaum *)
  BEGIN
    IF GehaltsBaum = NIL THEN
       GehaltsBaum:=p;
    ELSE
      IF p^.Gehalt > GehaltsBaum^.Gehalt THEN
        EinfuegenGehalt(GehaltsBaum^.rechtsGehalt);
      ELSE
        EinfuegenGehalt(GehaltsBaum^.linksGehalt);
      END;  (* IF *)
    END;  (* IF *)
  END EinfuegenGehalt;


PROCEDURE GehaltVon(NamensBaum:Zeiger);
 (* Ausgabe des Gehalts einer gewuenschten Person (Aufgabe 2b) *)
  VAR x:INTEGER;
  BEGIN
    IF NamensBaum = NIL THEN
      WrStr('Diesen Namen gibt es nicht !');
      WrLn;
    ELSE
      x:= Compare(name,NamensBaum^.Name);
      IF x > 0 THEN
        GehaltVon(NamensBaum^.rechtsName);
      ELSIF x < 0 THEN
        GehaltVon(NamensBaum^.linksName);
      ELSE
         WrLn;
        WrStr('Das Gehalt von ');
        WrStr(name);
        WrStr(' betraegt ');
        WrCard(NamensBaum^.Gehalt,0);
        WrLn;
      END;  (* IF *)
    END  (* IF *)
  END GehaltVon;


PROCEDURE Suche(GehaltsBaum:Zeiger);
(* Ausgabe einer Gehaltsliste mit dem Gehalt zwischen a und b
         (Aufg. 2c) *)
  BEGIN
    IF GehaltsBaum # NIL THEN
      Suche(GehaltsBaum^.linksGehalt);
      IF (GehaltsBaum^.Gehalt >= a)
         AND
         (GehaltsBaum^.Gehalt <= b) THEN
        WrStr(GehaltsBaum^.Name);
        WrCard(GehaltsBaum^.Gehalt,10);
         WrLn;
      END;  (* IF *)
      Suche(GehaltsBaum^.rechtsGehalt);
    END;  (* IF *)
  END Suche;


BEGIN  (* MAIN *)
  WrStr('Dieses Programm liest eine Reihe von Namen und die zugehrigen ');
  WrLn;
  WrStr(' Gehlter ein, und es kann das Gehalt einer bestimmten Person ');
  WrLn;
  WrStr(' ausgegeben werden, sowie die Gehlter und die zugehrigen');WrLn;
  WrStr(' Namen innerhalb einer Gehaltsspanne.'); WrLn;
  WrStr('    (Namenseingabe beenden durch Eingabe von: "*")');WrLn;WrLn;

  (* Aufg. 2a *)
  NamensBaum:=NIL;
  GehaltsBaum:=NIL;
  LOOP
    IF Einlesen() = TRUE THEN
      EinfuegenName(NamensBaum);
       EinfuegenGehalt(GehaltsBaum);
    ELSE
      EXIT
    END;  (* IF *)
  END;  (* LOOP *)
  WrLn;WrLn;

  (* Aufg. 2b *)
  WrStr('Es kann das Gehalt einer bestimmten Person ausgegeben werden.');
  WrLn;
  REPEAT
    WrLn;
    WrStr('Wessen Gehalt soll ausgegeben werden ? ');
    RdStr(name);
    WrLn;
    GehaltVon(NamensBaum); WrLn;WrLn;
    WrStr('Soll das Gehalt von weiteren Personen ausgegeben werden?');WrLn;
    WrStr('    ( [J]a oder [N]ein )');
    RdStr(janein);
    Caps(janein);
  UNTIL janein = "N";
  WrLn;WrLn;

  (* Aufg. 2c *)
  WrStr('Es knnen auch die Namen derer ausgegeben werden, deren ');WrLn;
  WrStr(' Gehalt innerhalb einer einzugebenden Spanne liegt.');WrLn;
  REPEAT
    WrLn;
    WrStr('Ausgabe einer Gehaltsliste');
    WrLn;
    REPEAT
      WrLn;
      WrStr('     von: ');
      ReadCard(a);
    UNTIL Done;
    WrLn;
    REPEAT
      WrLn;
      WrStr('     bis: ');
      ReadCard(b);
    UNTIL Done AND (b>=a);
    WrLn;
    Suche(GehaltsBaum); WrLn;WrLn;
    WrStr('    Noch einmal ?');WrLn;
     WrStr('    ( [J]a oder [N]ein )');
    RdStr(janein);
    Caps(janein);
  UNTIL janein = "N";

END Firma.
