MODULE Kinder;
(* n Kinder stellen sich einen Kreis bildend auf und fangen an, abzu-
   zhlen. Das k-te Kind mu dann ausscheiden, weitergezzhlt wird
   dann beim k+1-ten Kind.
   Das Programm fhrt dieses abzhlen nach Eingabe der Anzahl der Kinder
   und nach Eingabe der Zahl, welches Kind ausscheiden mu.
   Ausgegeben wird das Kind, welches brigbleibt.  *)

FROM InOut IMPORT WriteLn,WriteString,WriteCard,ReadCard,Done;
FROM Storage IMPORT ALLOCATE,DEALLOCATE;

TYPE RingListe=POINTER TO Kind;
     Kind=RECORD
            Name:CARDINAL;
            Nachbar:RingListe
          END;

VAR anfang,ende:RingListe;  (* anfang zeigt auf das erste Kind, *)
                            (* ende auf das letzte              *)
    n,k:CARDINAL;   (* n ist die Anzahl der Kinder, k gibt an,  *)
                    (* welches Kind ausscheidet                 *)

PROCEDURE Init;
(* diese Prozedur initialisiert die Ringliste *)
  BEGIN
    anfang:=NIL;
    ende:=NIL
  END Init;

PROCEDURE Anfuegen(p:RingListe);
(* diese Prozedur fgt ein Element an die Ringliste an *)
  BEGIN
    IF anfang=NIL THEN anfang:=p;
                  ende:=p;
                  p^.Nachbar:=p;
    ELSE ende^.Nachbar:=p;
         p^.Nachbar:=anfang;
         ende:=p;
    END;
  END Anfuegen;

PROCEDURE Herausnehmen(VAR p:RingListe);
(* diese Prozedur nimmt das Element, auf das p zeigt, aus der Liste *)
                                                          (* heraus *)
  VAR v:RingListe;
  BEGIN
    IF p=p^.Nachbar
    THEN WriteString('Nur noch ein Element in der Liste');
         WriteLn;
    ELSE v:=p;
         REPEAT
           v:=v^.Nachbar;
         UNTIL p=v^.Nachbar;
         v^.Nachbar:=p^.Nachbar;
         DISPOSE(p);
         p:=v^.Nachbar;
    END;  (* IF *)
  END Herausnehmen;

PROCEDURE Eingabe;
(* diese Prozedur liest n,k ein und ligt die Ringliste fr n Kinder an *)
  VAR p:RingListe;
      i:CARDINAL;
  BEGIN
    REPEAT
      WriteLn;
      WriteString('Bitte die Anzahl der Kinder eingeben (n>=1): ');
      ReadCard(n);
    UNTIL Done AND (n>=1);
    REPEAT
      WriteLn;
      WriteString('Das wievielte Kind soll ausscheiden? (k>=1): ');
      ReadCard(k);
    UNTIL Done AND (k>=1);
    WriteLn;
    FOR i:= 1 TO n DO
      NEW(p);
      p^.Name:=i;
      Anfuegen(p);
    END;
  END Eingabe;

PROCEDURE Ausscheiden;
(* diese Prozedur bewirkt, da jedes k-te Kind ausscheidet *)
  VAR p:RingListe;
      i:CARDINAL;
  BEGIN
    p:=anfang;
    WHILE p#p^.Nachbar DO
      FOR i:=2 TO k DO
        p:=p^.Nachbar;
      END;
      Herausnehmen(p);
    END;
    WriteString('Das Kind mit Nr. ');
    WriteCard(p^.Name,3);
    WriteString(' bleibt brig.');
    WriteLn;
  END Ausscheiden;

BEGIN   (* MAIN *)
  Init;
  Eingabe;
  Ausscheiden;
END Kinder.



