MODULE streich2_holz;
(* Streichholzspiel:
   Regeln: Zwei Haufen mit n und m Hlzchen, die Anzahl der Hlzchen
           kann beliebig gewhlt werden.
           Anschlieend kann gewhlt werden, wer mit dem Ziehen beginnt,
           der Computer oder Sie selbst.
           Zugmglichkeiten:
           Man kann von einem der Haufen beliebig viele Hlzchen
           wegnehmen (>=1), oder von beiden beiden Hufchen genau
           gleich viel wegnehmen (>=1).
   Ziel: Gewonnen hat der Spieler, der die letzten Hlzchen wegnimmt   *)

FROM IO IMPORT WrStr,WrLn,WrCard;
FROM InOut IMPORT Done,ReadCard;

VAR n,m,h1,h2,sp:CARDINAL;
    play,ende:BOOLEAN;

PROCEDURE backtrack(s:INTEGER):INTEGER;
(* Diese Prozedur  entscheidet ob bei der durch n und m gegebenen      *)
(* Spielsituation eine Gewinnstrategie fr den Spieler besteht, der    *)
(* anfngt, oder den anderen                                           *)

  VAR wert,fall,nummer,count,zahl:CARDINAL;
      i,diff:CARDINAL;

  PROCEDURE naechsteZahl(VAR x:CARDINAL);
  (* Diese Prozedur entscheidet, was der gnstigst Zug ist *)
    BEGIN
      IF fall=1 THEN
        CASE nummer OF
          1,3,4:x:=x+2 |
          2,5:INC(x)
        END;
        INC(nummer);
        IF nummer>5 THEN
          fall:=2;
          nummer:=1;
          zahl:=count;
        END
      ELSE
        CASE nummer OF
          1,3,4,6,7:x:=x+2 |
          2,5,8:INC(x)
        END;
        INC(nummer);
        IF nummer>8 THEN
          nummer:=1;
          DEC(zahl);
          IF zahl=0 THEN
            fall:=1;
            INC(count);
          END;
        END;
      END;
    END naechsteZahl;

  BEGIN   (* backtrack *)
    IF n=m THEN h1:=n;           (* Gewinnchance fr den, der anfngt *)
                h2:=m;
                RETURN s
    ELSIF n=0 THEN h1:=0;        (* Gewinnchance fr den, der anfngt *)
                   h2:=m;
                   RETURN s
    ELSIF m=0 THEN h1:=n;        (* Gewinnchance fr den, der anfngt *)
                   h2:=0;
                   RETURN s
    END;
    wert:=1;
    fall:=1;
    nummer:=1;
    count:=1;
    diff:=ABS(n-m);
    FOR i:=1 TO diff-1 DO
      naechsteZahl(wert);
    END;
    IF (n>wert) AND (m>wert+diff) AND (n<m) THEN
                                 (* Gewinnchance fr den, der anfngt *)
      h1:=n-wert;
      h2:=h1;
      RETURN s
    ELSIF (m>wert) AND (n>wert+diff) AND (n>m) THEN
                                 (* Gewinnchance fr den, der anfngt *)
      h2:=m-wert;
      h1:=h2;
      RETURN s
    END;
    wert:=1;
    fall:=1;
    nummer:=1;
    count:=1;
    FOR i:=1 TO diff DO
      IF ((n=wert) AND (m=wert+i)) OR
         ((m=wert) AND (n=wert+i)) THEN RETURN -s
                           (* Gewinnchance fr den, der nicht anfngt *)
      ELSIF (n=wert) AND (m>wert+i) THEN h1:=0;h2:=m-wert-i;RETURN s
                                 (* Gewinnchance fr den, der anfngt *)
      ELSIF (m=wert) AND (m>wert+i) THEN h1:=n-wert-i;h2:=0;RETURN s
                                 (* Gewinnchance fr den, der anfngt *)
      ELSIF (n=wert+i) AND (m>wert) THEN h1:=0;h2:=m-wert;RETURN s
                                 (* Gewinnchance fr den, der anfngt *)
      ELSIF (m=wert+i) AND (n>wert) THEN h1:=n-wert;h2:=0;RETURN s
                                 (* Gewinnchance fr den, der anfngt *)
      ELSE naechsteZahl(wert);
      END;
    END;
    RETURN -s      (* Wenn keiner der obigen Flle zutrifft, hat der *)
                   (* die Gewinnchance,der nicht anfngt             *)
  END backtrack;

  PROCEDURE zug(a,b:CARDINAL);
  (* Es wird eingelesen, wieviele Hlzer weggenommen werden sollen *)
    BEGIN
      WrCard(a,3);
      WrStr('    ');
      WrCard(b,3);
      WrLn;
    END zug;

  PROCEDURE haufen(a,b:CARDINAL);
  (* Schreibt die Anzahl der noch auf den Hufchen befindlichen Hlzchen *)
  (* an                                                                  *)
    BEGIN
      WrStr('Haufen 1: ');
      WrCard(a,3);
      WrStr('    Haufen 2: ');
      WrCard(b,3);
      WrLn;
    END haufen;

BEGIN   (* main *)
  WrStr('       STREICHHOLZ-SPIEL ');WrLn;WrLn;WrLn;
  REPEAT   (* Eingabe der Anzahl der Hlzchen auf Haufen 1 *)
    WrLn;
    WrStr('geben Sie die Zahl der Hoelzer auf Haufen 1 ein: ');
    ReadCard(n);
  UNTIL Done AND (n>0);
  REPEAT   (* Eingabe der Anzahl der Hlzchen auf Haufen 2 *)
    WrLn;
    WrStr('Geben Sie die Zahl der Hoelzer auf Haufen 2 ein_ ');
    ReadCard(m);
  UNTIL Done AND (m>0);
  REPEAT   (* Eingabe, wer anfangen soll *)
    WrLn;
    WrStr('Geben Sie an, wer anfangen soll (1=Computer, 2=Spieler): ');
    ReadCard(sp);
  UNTIL Done AND(sp>=1) AND (sp<=2);
  WrLn;
  WrLn;
  play:=(sp=1);
  haufen(n,m);
  ende:=FALSE;
  REPEAT
    IF play THEN     (* Wenn der Computer den ersten Zug macht *)
      IF backtrack(1)=1 THEN     (* Wenn Computer hat Gewinnchance *)
        n:=n-h1;
        m:=m-h2;
        WrStr('MeinZug: ');
        zug(h1,h2);
        haufen(n,m);
        IF (m=0) AND (n=0) THEN WrStr('Ich habe gewonnen!');
                                WrLn;
                                ende:=TRUE
        END;
      ELSE                       (* Wenn User hat Gewinnchance *)
        IF n>1 THEN
          DEC(n);
          WrStr('Mein Zug: ');
          zug(1,0);
          haufen(n,m);
        ELSIF m>1 THEN
          DEC(m);
          WrStr('Mein Zug: ');
          zug(0,1);
          haufen(n,m);
        ELSE
          WrStr('Du hast gewonnen!');
          WrLn;
          ende:=TRUE;
        END;  (* IF *)
      END;  (* IF *)
    ELSE                     (* Wenn User anfngt *)
      IF NOT ende THEN       (* Wenn das Spiel noch nicht zu Ende ist, *)
        REPEAT               (* einlesen, wieviel genommen werden soll *)
          WrStr('Dein Zug: ');
          ReadCard(h1);
          WrStr('    ');
          ReadCard(h2);
          WrLn;
        UNTIL (h1+h2>0) AND ((h1=0) OR (h2=0) OR (h1=h2))
              AND (h1<=n) AND (h2<=m);
        n:=n-h1;
        m:=m-h2;
        haufen(n,m);
        IF (n=0) AND (m=0) THEN   (* Wenn das Spiel bereits zu Ende ist *)
          WrStr('Du hast gewonnen!');
          WrLn;
          ende:=TRUE;
        END;  (* IF *)
      END;  (* IF *)
    END;  (* IF *)
    play:=NOT play;
  UNTIL ((n=0) AND (m=0)) OR ende;
  WrLn;
END streich2_holz.




