MODULE testkomplex;

(* Komplex:
   Dieses Programm dient dem Rechnen mit komplexen Zahlen.
   Es werden zwei komplexe Zahlen eingegeben, wobei der Realteil
   und der Imaginrteil explizit abgefragt werden.
   Danach stehen mehrere Operationsmglichkeiten mit den beiden
   komplexen Zahlen zur Verfgung.
   Als da wren: * Addition
                 * Subtraktion
                 * Multiplikation
                 * Quotient
                 zweier komplexen Zahlen.
                 auerdem
                 * Betrag einer komplexen Zahl
                 * Test auf Gleichheit zweier komplexen Zahlen.
 *)

FROM adtkomplex IMPORT Komplex,Kreieren,Setzen,RT,IT,Summe,Differenz,
                       Betrag,Produkt,Quotient,Gleich;
FROM IO IMPORT WrStr,WrLn,RdStr,WrCard,RdCard;
FROM RealInOut IMPORT ReadReal,WriteReal;
FROM InOut IMPORT ReadCard,Read,Write;


VAR A,B,Z:Komplex;
    auswahl:CARDINAL;
    rt,it:REAL;
    tf:BOOLEAN;
    jn:CHAR;


BEGIN
  WrLn;
  WrStr('    Rechnen mit komplexen Zahlen: ');WrLn;
  WrStr('    ----------------------------- ');
  WrLn;
  REPEAT

    Kreieren(A);
    WrStr('Eingabe von A (Realzahl): ');WrLn;
    WrStr('     Realteil: ');
    ReadReal(rt);WrLn;
    WrStr(' Imaginrteil: ');
    ReadReal(it);WrLn;
    Setzen(A,rt,it);WrLn;

    Kreieren(B);
    WrStr('Eingabe von B (Realzahl): ');WrLn;
    WrStr('     Realteil: ');
    ReadReal(rt);WrLn;
    WrStr(' Imaginrteil: ');
    ReadReal(it);WrLn;
    Setzen(B,rt,it);WrLn;

    Kreieren(Z);
    Setzen(Z,0.0,0.0);

    REPEAT
      WrLn;WrLn;
      WrStr('Treffen Sie eine Auswahl:');WrLn;
      WrStr('  1: Summe: a+b;     2: Differenz: a-b;  3: Produkt: a*b;');WrLn;
      WrStr('  4: Quotient: a/b;  5: Betrag: a;     6: Gleichheit: a=b?; ');
      WrLn;
      ReadCard(auswahl);WrLn;
      CASE auswahl OF
        1: WrLn;
           Summe(A,B,Z);
           WrStr(' Summe  A+B:');WrLn;
           WrStr(' Realteil: '); WriteReal(RT(Z),5);WrLn;
           WrStr(' Imaginrteil: '); WriteReal(IT(Z),5);WrLn;|
        2: WrLn;
           Differenz(A,B,Z);
           WrStr(' Differenz A-B:');WrLn;
           WrStr(' Realteil: '); WriteReal(RT(Z),5);WrLn;
           WrStr(' Imaginrteil: '); WriteReal(IT(Z),5);WrLn;|
        3: WrLn;
           Produkt(A,B,Z);
           WrStr(' Produkt  A*B: ');WrLn;
           WrStr(' Realteil: '); WriteReal(RT(Z),5);WrLn;
           WrStr(' Imaginrteil: '); WriteReal(IT(Z),5);WrLn;|
        4: WrLn;
           Quotient(A,B,Z);
           WrStr('Quotient  A/B: ');WrLn;
           WrStr(' Realteil: '); WriteReal(RT(Z),5);WrLn;
           WrStr(' Imaginrteil: '); WriteReal(IT(Z),5);WrLn;|
        5: WrLn;
           WrStr(' Betrag = ');
           WriteReal(Betrag(A),5);WrLn;|
        6: WrLn;
           tf:=Gleich(A,B);
           IF tf THEN WrStr('Zahlen sind identisch. '); WrLn;
           ELSE WrStr('Zahlen sind nicht identisch. ');WrLn;
           END;  (* IF *)
      ELSE WrStr('Falsche Eingabe. ');WrLn;
      END;  (* CASE *)
      WrLn;
      WrStr(' Soll eine weitere Berechnung mit A,B durchgefhrt werden?  ');
      Read(jn); Write(jn);WrLn;
    UNTIL (jn="n") OR (jn="N");
    WrLn;WrLn;
    WrStr('Sollen die Zahlen A,B neu gesetzt werden?  ');
    Read(jn); Write(jn);WrLn;
  UNTIL (jn="n") OR (jn="N");
END testkomplex.
