IMPLEMENTATION MODULE HerculesGraphics;

FROM SYSTEM IMPORT CODE, SETREG, GETREG,
                   AX, DI, BP, BX, CX,
                   SWI;

CONST
    LeftBit = 0;
    RightBit = 719;
    TopBit = 0;
    BottomBit = 347;
    PushBP  = 55H;
    PopBP   = 5DH; 
    MOV     = 089H;
    DItoBP  = 00H;

VAR
    c1, c2, size, size2 : CARDINAL;
    select, piece : CARDINAL;

  PROCEDURE Arc (x, y, radius, quad : CARDINAL);
    BEGIN
      c1 := x;
      c2 := y;
      size := radius;
      piece := quad;
      CODE(PushBP);
      SETREG (AX, 4C00H + piece);
      SETREG (DI, c1);
      SETREG (BX, c2);
      CODE (8BH, 0EBH);
      SETREG (BX, size);
      SWI (10H);
      CODE(PopBP);
    END Arc;

  PROCEDURE BlkFil (x,y, width, height : CARDINAL);
    BEGIN
      c1 := x;
      c2 := y;
      size := width;
      size2 := height;
      CODE(PushBP);
      SETREG (AX,4A00H);
      SETREG (DI, c1);
      SETREG (BX, c2);
      CODE (8BH, 0EBH);
      SETREG (CX,size);
      SETREG (BX,size2);
      SWI (10H);
      CODE(PopBP);
    END BlkFil;

  PROCEDURE Circ (x, y, radius : CARDINAL);
    BEGIN
      c1 := x;
      c2 := y;
      size := radius;
      CODE(PushBP);
      SETREG (AX,4D00H);
      SETREG (DI, c1);
      SETREG (BX, c2);
      CODE (8BH, 0EBH);
      SETREG (BX, size);
      SWI (10H);
      CODE(PopBP);
    END Circ;

  PROCEDURE ClrScr;
    BEGIN
      SETREG (AX,4200H);
      SWI (10H);
    END ClrScr;

  PROCEDURE Disp (bufpage : CARDINAL);
    BEGIN
      select := bufpage;
      SETREG (AX,4500H + select);
      SWI (10H);
    END Disp;

  PROCEDURE Dline (x, y : CARDINAL);
    BEGIN
      c1 := x;
      c2 := y;
      CODE(PushBP);
      SETREG (AX, 4900H);
      SETREG (DI, c1);
      SETREG (BX, c2);
      CODE (8BH, 0EBH);     (* MOV BP,BX *)
      SWI (10H);
      CODE(PopBP);
    END Dline;

  PROCEDURE Fill (x,y : CARDINAL);
    BEGIN
      c1 := x;
      c2 := y;
      CODE(PushBP);
      SETREG (AX, 4E00H);
      SETREG (DI, c1);
      SETREG (BX, c2);
      CODE (8BH, 0EBH);     (* MOV BP,BX *)
      SWI (10H);
      CODE(PopBP);
    END Fill;

  PROCEDURE GetPt (x, y : CARDINAL;
                   VAR intens : CARDINAL);
    BEGIN
      c1 := x;
      c2 := y;
      CODE(PushBP);
      SETREG (AX,4700H);
      SETREG (DI, c1);
      SETREG (BX, c2);
      CODE (8BH, 0EBH);     (* MOV BP,BX *)
      SWI (10H);
      CODE(PopBP);

      GETREG (AX,select);
      intens := select MOD 100H;
    END GetPt;

  PROCEDURE Gmode;
    BEGIN
      SETREG (AX,4000H);
      SWI (10H);
    END Gmode;

  PROCEDURE Gpage (bufpage : CARDINAL);
    BEGIN
      select := bufpage;
      SETREG (AX,4300H + select);
      SWI (10H);
    END Gpage;

  PROCEDURE Level (intens : CARDINAL);
    BEGIN
      select := intens;
      SETREG (AX,4400H + select);
      SWI (10H);
    END Level;

  PROCEDURE Move (x, y : CARDINAL);
    BEGIN
      c1 := x;
      c2 := y;
      CODE(PushBP);
      SETREG (AX,4800H);
      SETREG (DI, c1);
      SETREG (BX, c2);
      CODE (8BH, 0EBH);     (* MOV BP,BX *)
      SWI (10H);
      CODE(PopBP);
    END Move;

  PROCEDURE Plot (x, y : CARDINAL);
    BEGIN
      c1 := x;
      c2 := y;
      CODE(PushBP);
      SETREG (AX,4600H);
      SETREG (DI, c1);
      SETREG (BX, c2);
      CODE (8BH, 0EBH);     (* MOV BP,BX *)
      SWI (10H);
      CODE(PopBP);
    END Plot;

  PROCEDURE PutPt (x, y : CARDINAL);
    BEGIN
      c1 := x;
      c2 := y;
      CODE(PushBP);
      SETREG (AX,4700H);
      SETREG (DI, c1);
      SETREG (BX, c2);
      CODE (8BH, 0EBH);     (* MOV BP,BX *)
      SWI (10H);
      CODE(PopBP);
    END PutPt;

  PROCEDURE Text (x, y : CARDINAL;
                  c : CHAR);
    BEGIN
      c1 := x;
      c2 := y;
      piece := ORD (c) MOD 100H;
      CODE(PushBP);
      SETREG (AX,4B00H + piece);
      SETREG (DI, c1);
      SETREG (BX, c2);
      CODE (8BH, 0EBH);     (* MOV BP,BX *)
      SWI (10H);
      CODE(PopBP);
    END Text;


  PROCEDURE Tmode;
    BEGIN
      SETREG (AX,4100H);
      SWI (10H);
    END Tmode;

END HerculesGraphics.
